// Packet buffer implementation file

#include "PacketBuffer.h"
#include <stdio.h>

Packet_Buffer::Packet_Buffer()
{
  top = -1;
  numPushs = 0;
  numPops = 0;
  
  p_out_stack[MAX_BUFF] = new UDPpacket[MAX_BUFF]; //make it real.
}

Packet_Buffer::~Packet_Buffer()
{
  delete p_out_stack[MAX_BUFF];
}

bool Packet_Buffer::isEmpty() const
{
  if (top <= 0)
    return true;
  else
    return false;
}

void Packet_Buffer::push(UDPpacket **packet_in)
{
  if (top < MAX_BUFF)
  {
    top++;
    p_out_stack[top] = *packet_in;    
  }
  
  else
    printf("\nERROR Writing to stack! Stack full!\n");
}

UDPpacket* Packet_Buffer::pop()
{
  top--;
  return p_out_stack[top + 1];
}

UDPpacket* Packet_Buffer::handle_oldest()
{
  return p_out_stack[0];
}
